// -------------------------------------------------------------------------------------
//
// AnalogScanner.CS                                               Ulrich Mller 21.06.05
//                                                                PCS1700   C# Final SP2
// Scannen der Werte eines Photowiderstandes an AX durch Drehung um die vertikale
// Achse im Bereich von 0 bis 222 Impulsen
//
// Nutzung von FishDevices40.DLL / umFish40.DLL
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using FishDevices40;

namespace AnalogScanner {
	public class frmMain : System.Windows.Forms.Form {
		private System.Windows.Forms.Label lblPhoto;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Label lblPos;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblLow;
		private System.Windows.Forms.Label lblHigh;
		private System.Windows.Forms.ProgressBar pgbPhoto;
		private System.ComponentModel.Container components = null;

		// --- RoboFace : Deklarationen -----------------------------

		private FishDevices   fd;
		private RobMotor      Turm;
		private PhotoResistor Photo;

		public frmMain() {
			InitializeComponent();

			// --- RoboFace : Instanzierung, Ereignisse --------------

			fd    = new FishDevices();
			Turm  = new RobMotor(fd, Out.M1, 175);
			Photo = new PhotoResistor(fd, Inp.AX, 333, 555);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			this.cmdAction = new System.Windows.Forms.Button();
			this.lblPhoto = new System.Windows.Forms.Label();
			this.lblPos = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.lblLow = new System.Windows.Forms.Label();
			this.lblHigh = new System.Windows.Forms.Label();
			this.pgbPhoto = new System.Windows.Forms.ProgressBar();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(80, 192);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(136, 32);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// lblPhoto
			// 
			this.lblPhoto.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPhoto.Location = new System.Drawing.Point(96, 56);
			this.lblPhoto.Name = "lblPhoto";
			this.lblPhoto.TabIndex = 1;
			this.lblPhoto.Text = "0";
			this.lblPhoto.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblPos
			// 
			this.lblPos.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPos.Location = new System.Drawing.Point(96, 152);
			this.lblPos.Name = "lblPos";
			this.lblPos.TabIndex = 2;
			this.lblPos.Text = "0";
			this.lblPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(88, 128);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Position";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(56, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(104, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Analogwert";
			// 
			// lblLow
			// 
			this.lblLow.Location = new System.Drawing.Point(64, 56);
			this.lblLow.Name = "lblLow";
			this.lblLow.Size = new System.Drawing.Size(24, 24);
			this.lblLow.TabIndex = 5;
			// 
			// lblHigh
			// 
			this.lblHigh.BackColor = System.Drawing.SystemColors.Control;
			this.lblHigh.Location = new System.Drawing.Point(208, 56);
			this.lblHigh.Name = "lblHigh";
			this.lblHigh.Size = new System.Drawing.Size(24, 24);
			this.lblHigh.TabIndex = 6;
			// 
			// pgbPhoto
			// 
			this.pgbPhoto.Location = new System.Drawing.Point(56, 88);
			this.pgbPhoto.Maximum = 1024;
			this.pgbPhoto.Name = "pgbPhoto";
			this.pgbPhoto.Size = new System.Drawing.Size(176, 24);
			this.pgbPhoto.TabIndex = 7;
			this.pgbPhoto.Value = ((int)(configurationAppSettings.GetValue("pgbPhoto.Value", typeof(int))));
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(292, 251);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pgbPhoto,
																		  this.lblHigh,
																		  this.lblLow,
																		  this.label2,
																		  this.label1,
																		  this.lblPos,
																		  this.lblPhoto,
																		  this.cmdAction});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "FishDevices40 : AnalogScanner";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}


		// --- ScanAnalog : Anzeige der Analogwerte, Kontrolle der Drehung des Turms ---

		private void ScanAnalog(object sender, int Pos, bool Ready) {
			lblPhoto.Text = Photo.ActualValue.ToString();
			pgbPhoto.Value = Photo.ActualValue;
			lblPos.Text   = Pos.ToString();
			if(Ready && Pos == 0) Turm.DriveTo(Turm.MaxPosition);
			else if(Ready && Pos == Turm.MaxPosition) Turm.DriveTo(0);
		}
		// --- Hoch/Niedrig : Grenzwertberschreitung -------------------
		private void Hoch(object sender, int Wert) {
			lblLow.BackColor  = Color.Gray;
			lblHigh.BackColor = Color.Red;
		}
		private void Niedrig(object sender, int Wert) {
			lblLow.BackColor  = Color.Red;
			lblHigh.BackColor = Color.Gray;
		}
		private void Normal(object sender, int Wert) {
			lblLow.BackColor  = Color.Gray;
			lblHigh.BackColor = Color.Gray;
		}

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try {
				if(cmdAction.Text == "&START") {
					fd.Connect(IFTypen.ftIntelligent_IF, Port.COM2, 5);
					fd.Start();
					cmdAction.Text = "&HALT";

					Turm.DriveHome();
					Turm.WaitForDone();

					Turm.ChangedPosition  += new RobMotor.Position(ScanAnalog);
					Photo.ChangedToHigh   += new AnalogInput.Limit(Hoch);
					Photo.ChangedToLow    += new AnalogInput.Limit(Niedrig);
					Photo.ChangedToNormal += new AnalogInput.Limit(Normal);

					Normal(this,0);
					Turm.DriveTo(Turm.MaxPosition);
				}
				else {
					lblPhoto.Text = "Ende";
					fd.DisConnect();
					this.Close();
				}
			}
			catch(FishDevException efd) {
				lblPhoto.Text = efd.Message;
			}
		}

	}
}
