// -----------------------------------------------------------------------------------
//
// DreipunktLampenBlinker.CS                                    Ulrich Mller 08.11.04
//                                                              PCS1700   C# Final SP2
// Einfache Dreipunkt-Regelung mit Anzeige des aktuellen Wertes
//          Event-Lsung : Lampe.BlinkingOn, wenn nicht Normal
// Einsatz von FishDevices30.DLL / umFish30.DLL
// 
// -----------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishDevices30;

namespace Dreipunkt
{
	public class frmMain : System.Windows.Forms.Form	{

		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Button cmdAction;
		private System.ComponentModel.Container components = null;

		// --- Dreipunkt : Deklarationen ------------------------

		private FishDevices   fd;
		private DLamp         LampeHigh;
		private DLamp         LampeLow;
		private PhotoResistor Photo;

		public frmMain() {
			InitializeComponent();

			// --- Dreipunkt : Instanzierung, Ereignisse ---------------

			fd     = new FishDevices(true, false, 0);
			LampeHigh = new DLamp(fd, Nr.M1);
			LampeLow = new DLamp(fd, Nr.M2);
			Photo  = new PhotoResistor(fd, Nr.EX, 333, 555);

			Photo.ChangedToHigh   += new AnalogInput.Limit(Hoch);
			Photo.ChangedToLow    += new AnalogInput.Limit(Niedrig);
			Photo.ChangedToNormal += new AnalogInput.Limit(Normal);
			Photo.ShowActualValue += new AnalogInput.Limit(ShowValue);
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent() {
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdAction = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(24, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(296, 24);
			this.lblStatus.TabIndex = 0;
			this.lblStatus.Text = "START drcken";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(24, 56);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(296, 40);
			this.cmdAction.TabIndex = 1;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(336, 117);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.cmdAction,
																																	this.lblStatus});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "FishDevices30 : Dreipunkt-Regelung";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new frmMain());
		}


		// --- Ereignis-Routinen ----------------------------------

		private void Hoch(object sender, int Wert) {
			LampeHigh.BlinkingOn(333);
		}
		private void Niedrig(object sender, int Wert) {
			LampeLow.BlinkingOn(234, 123);
		}
		private void Normal(object sender, int Wert) {
			LampeHigh.BlinkingOff();
			LampeLow.BlinkingOff();
		}
		private void ShowValue(object sender, int Wert) {
			lblStatus.Text = Wert.ToString();
		}
		
		// ------------- Klick-Routinen ------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try{
				if(cmdAction.Text == "&START") {
					fd.Connect(Port.COM2);
					fd.Start();
					Photo.ThreadInterval = 234;
					cmdAction.Text = "&ENDE";
				}
				else {
					fd.DisConnect();
					this.Close();
				}
			}
			catch(FishDevException efd) {
				lblStatus.Text = efd.Message;
			}
		}
	}
}
