// ------------------------------------------------------------------------------------
//
// FishDevTest.CS                                                Ulrich Mller 21.06.05
//                                                               PCS1700   C# Final SP2
// Testrahmen fr die Klassenbibliothek : FishDevices
//
// ------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishDevices40;

namespace FishDevTest {
	public class frmMain : System.Windows.Forms.Form {
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Button cmdAction;
		private System.ComponentModel.Container components = null;

		// --- FishDevices : Klassen-Deklarationen --------------------------
		private FishDevices fd;

		private BinaryInput I1;
		private IRInput     M1FW;
		private FishPanel   fishPanel;

		private DualOutput  M3;

		public frmMain() {
			InitializeComponent();

			// --- FishDevices : Instanzierung, Ereignisse ------------------
			fd = new FishDevices();

			I1 = new BinaryInput(fd, 1);
			I1.ChangedToFalse += new BinaryInput.Changed(ToFalse);
			I1.ChangedToTrue  += new BinaryInput.Changed(ToTrue);

			M1FW = new IRInput(fd, IRCode.Code1, IRKeys.M1FW);
			M1FW.ChangedToTrue  += new IRInput.Changed(ToTrue);
			M1FW.ChangedToFalse += new IRInput.Changed(ToFalse);

			M3 = new DualOutput(fd, Out.M3);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdAction = new System.Windows.Forms.Button();
			this.fishPanel = new FishDevices40.FishPanel();
			this.SuspendLayout();
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(16, 288);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(264, 40);
			this.lblStatus.TabIndex = 0;
			this.lblStatus.Text = "START drcken";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdAction
			// 
			this.cmdAction.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdAction.Location = new System.Drawing.Point(16, 336);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(264, 40);
			this.cmdAction.TabIndex = 1;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// fishPanel
			// 
			this.fishPanel.Analog = true;
			this.fishPanel.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.fishPanel.Interface = null;
			this.fishPanel.Location = new System.Drawing.Point(16, 16);
			this.fishPanel.Name = "fishPanel";
			this.fishPanel.Size = new System.Drawing.Size(264, 256);
			this.fishPanel.Slave = false;
			this.fishPanel.TabIndex = 2;
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.CancelButton = this.cmdAction;
			this.ClientSize = new System.Drawing.Size(294, 395);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.fishPanel,
																		  this.cmdAction,
																		  this.lblStatus});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "FishDevices40 : Testrahmen";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}


		// --- Die Event-Routinen -----------------------------------------

		private void ToTrue(object sender) {
			DeviceBase bi = (DeviceBase)sender;
			lblStatus.Text = bi.DeviceNumber.ToString("I0 : ToTrue");
			M3.Left();
		}
		private void ToFalse(object sender) {
			DeviceBase bi = (DeviceBase)sender;
			lblStatus.Text = bi.DeviceNumber.ToString("I0 : ToFalse");
			M3.Off();
		}

		// --- cmdAction : Start/Stop -------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try {
				if(cmdAction.Text == "&START") {
					fd.Connect(IFTypen.ftROBO_first_USB, 0);
					fd.Start();
					fishPanel.Interface = fd;
					fishPanel.Analog    = true;
					fishPanel.Slave     = false;
					fishPanel.Start();
					cmdAction.Text = "&HALT";
					lblStatus.Text = "--- luft ---";
					lblStatus.Text = M3.GetType().Name;
				}
				else {
					lblStatus.Text = "ENDE";
					fishPanel.Stop();
					fd.DisConnect();
					this.Close();
				}
			}
			catch(FishDevException efd) {
				lblStatus.Text = efd.Message + ". Mit x beenden";
			}
		}
	}
}
