// -------------------------------------------------------------------------------------
//
// HanoiMain.CS                                                   Ulrich Mller 21.06.05
//                                                                PCS1700   C# Final SP2
// Lsung des Problems "Turm von Hanoi" mit einem einfachen Roboter
// Einsatz von FishDevices40.DLL / umFish40.DLL
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishDevices40;

namespace HanoiRobot
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Button cmdAction;
		private System.ComponentModel.Container components = null;
		private HanoiRobot hr;

		public frmMain() {
			InitializeComponent();
			// --- PortNummer (hier COM2) ggf. ndern
			hr = new HanoiRobot(IFTypen.ftIntelligent_IF, Port.COM2);
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdAction = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(16, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(320, 32);
			this.lblStatus.TabIndex = 0;
			this.lblStatus.Text = "START drcken";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(16, 64);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(320, 40);
			this.cmdAction.TabIndex = 1;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(352, 125);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.cmdAction,
																																	this.lblStatus});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "RoboFace : Turm von Hanoi";
			this.ResumeLayout(false);

		}
		#endregion
		[STAThread]
		static void Main() {
			Application.Run(new frmMain());
		}

		
		// --- Hauptprogramm --------------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try {
				if(cmdAction.Text == "&START") {
					lblStatus.Text = "Fhrt auf Grundstellung";
					cmdAction.Text = "&HALT";
					hr.Start();

					// --- Start von Hanoi mit 3 Scheiben ----------

					Hanoi(3, hr.PosLinks, hr.PosMitte, hr.PosRechts);
					lblStatus.Text = "FINIS";
					cmdAction.Text = "&ENDE";
				}
				else {
					lblStatus.Text = "Hanoi wird beendet";
					hr.Stop();
					this.Close();
				}
			}
			catch (FishDevException efd) {
				lblStatus.Text = efd.Message;
			}	
		}

		// --- Die Hanoi-Routine (rekursiv) ---------------------

		private void Hanoi(int n, int TAnf, int TMit, int TEnd) {
			if(n == 1) {
				lblStatus.Text = "Scheibe von " + TAnf.ToString() + " -> " 
					+ TEnd.ToString();
				Ziehe(TAnf, TEnd);
			}
			else {
				Hanoi(n-1, TAnf, TEnd, TMit);
				lblStatus.Text = "Scheibe von " + TAnf.ToString() + " -> " 
					+ TEnd.ToString();
				Ziehe(TAnf, TEnd);
				Hanoi(n-1, TMit, TAnf, TEnd);
			}
		}
		// --- Ziehe eine Scheiben von - nach ------------------

		private void Ziehe(int Von, int Nach) {
			Hole(Von);
			Bringe(Nach);
		}
		
		// --- Hole eine Scheibe von Position ----------------------------

		private void Hole(int Pos) {
			hr.SauleNach(Pos);
			hr.ArmSenken();
			hr.ScheibeGreifen();
			hr.ArmHeben();
		}

		// --- Bringe eine Scheibe nach Position -------------------

		private void Bringe(int Pos) {
			hr.SauleNach(Pos);
			hr.ArmSenken();
			hr.ScheibeLegen();
			hr.ArmHeben();
		}
	}
}
