// --------------------------------------------------------------------------------------
//
// HanoiRobot.CS                                                   Ulrich Mller 21.06.05
//                                                                 PCS1700   C# Final SP2
// Klasse HanoiRobot : Betrieb des Roboters (Linear)
// Einsatz von FishDevices40.DLL / umFish40.DLL
//
// --------------------------------------------------------------------------------------

using System;
using FishDevices40;

namespace HanoiRobot {
	public class HanoiRobot	{
		private FishDevices  fd;
		private RobMotor     mSaule;
		private LimitedMotor mArm;
		private DMagnet      mGreifer;

		private IFTypen      ifTyp;
		private Port         ComNr;
		private int          PosA;
		private int          PosB;
		private int          PosC;

		public HanoiRobot(IFTypen ifTyp, Port ComNr) {
			this.ifTyp = ifTyp;
			this.ComNr = ComNr;
			fd         = new FishDevices();
			mSaule     = new RobMotor(fd,     false, Out.M1, 180);
			mArm       = new LimitedMotor(fd, false, new Motor(fd,  Out.M2), 
				                                     new Sensor(fd, Inp.I4), 
						  						     new Sensor(fd, Inp.I3));
			mGreifer = new DMagnet(fd, Out.M3);

			PosA = 14;
			PosB = 52;
			PosC = 95;
		}

		public int PosLinks {
			get{return PosA;}
			set{PosA = value;}
		}
		public int PosMitte {
			get{return PosB;}
			set{PosB = value;}
		}
		public int PosRechts {
			get{return PosC;}
			set{PosC = value;}
		}

		public void Start() {
			fd.Connect(ifTyp, ComNr, 0);
			Grundstellung();
		}
		public void Stop() {
			fd.DisConnect();
		}

		public void Grundstellung(){
			mGreifer.Off();
			mArm.GoRight();
			mArm.WaitForDone();
			mSaule.DriveHome();
			mSaule.WaitForDone();
			mSaule.DriveTo(PosA);
			mSaule.WaitForDone(); 
		}
		public void SauleNach(int ZielPos) {
			mSaule.DriveTo(ZielPos);
			mSaule.WaitForDone();
		}
		public void ArmSenken() {
			mArm.GoLeft();
			mArm.WaitForDone();
		}
		public void ArmHeben() {
			mArm.GoRight();
			mArm.WaitForDone();
		}
		public void ScheibeLegen() {
			mGreifer.Off();
		}
		public void ScheibeGreifen() {
			mGreifer.On();
		}
	}
}
