// -------------------------------------------------------------------------------------
//
// RobCycle.CS                                                    Ulrich Mller 21.06.05
//                                                                PCS1700   C# Final SP2
// Industry Robot : SulenRoboter
// Steuerung des Roboters in einem Zyklus
//
// Robotaufbau entsprechend Bauanleitung
// Einsatz von FishDevices40.DLL / umFish40.DLL
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using FishDevices40;

namespace RobCycle {
	public class frmMain : System.Windows.Forms.Form {
		private System.Windows.Forms.Button cmdZyklus;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.ComboBox cboPortName;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Button cmdAction;
		private System.ComponentModel.Container components = null;

		// --- FishDevices : Klassendeklarationen --------------------

		private FishDevices fd;
		private RobMotors   iRob;

		public frmMain() {
			InitializeComponent();

			// --- FishDevices : Instanzierung, Ereignisse ------

			fd    = new FishDevices();
			iRob  = new RobMotors(fd, true,
				    new RobMotor(fd, Out.M1, 222),     // --- Sule
				    new RobMotor(fd, Out.M3, 111),     // --- Arm vertikal
				    new RobMotor(fd, Out.M2, 88),      // --- Arm horizontal
				    new RobMotor(fd, Out.M4, 26));     // --- Greifer

			cboPortName.SelectedIndex = 2;
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.cmdZyklus = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdZyklus
			// 
			this.cmdZyklus.Enabled = false;
			this.cmdZyklus.Location = new System.Drawing.Point(72, 40);
			this.cmdZyklus.Name = "cmdZyklus";
			this.cmdZyklus.Size = new System.Drawing.Size(136, 32);
			this.cmdZyklus.TabIndex = 1;
			this.cmdZyklus.Text = "&Zyklus";
			this.cmdZyklus.Click += new System.EventHandler(this.cmdZyklus_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.Color.White;
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(16, 104);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(232, 32);
			this.lblStatus.TabIndex = 2;
			this.lblStatus.Text = "START drcken";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cboPortName
			// 
			this.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPortName.Items.AddRange(new object[] {
															 "USB",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(72, 160);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(136, 21);
			this.cboPortName.TabIndex = 3;
			// 
			// cmdEnde
			// 
			this.cmdEnde.Location = new System.Drawing.Point(72, 200);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(136, 32);
			this.cmdEnde.TabIndex = 4;
			this.cmdEnde.Text = "&ENDE";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(72, 248);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(136, 32);
			this.cmdAction.TabIndex = 5;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(264, 307);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdZyklus,
																		  this.cmdAction,
																		  this.cmdEnde,
																		  this.cboPortName,
																		  this.lblStatus});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "RoboFace : RobCycle";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		
		// --- RobPosition : Ereignisroutine Anzeige Roboter-Position ----

		private void RobPosition(object sender, int[] Pos, bool Ready) {
			lblStatus.Text = Pos[0].ToString() + " - " + Pos[1].ToString() + " - "
				+ Pos[2].ToString();
		}

		// --- cmdAction_Click : Start-Routine ------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try{
				if(cboPortName.SelectedIndex == 0) {
					fd.Connect(IFTypen.ftROBO_first_USB, 0);
				}
				else {
					fd.Connect(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 0);
				}
				fd.Start();
				cmdAction.Enabled = false;
				lblStatus.Text = "Nach Hause";
				iRob.MoveHome();
				iRob.WaitForDone();
				iRob.ChangedPosition += new RobMotors.PositionS(RobPosition);
				cmdZyklus.Enabled = true;
			}
			catch(FishDevException efd) {
				lblStatus.Text = efd.Message;
			}
		}

		// --- cmdEnde_Click : Ende-Routine mit Parken --------------------

		private void cmdEnde_Click(object sender, System.EventArgs e) {
			cmdEnde.Enabled = false;
			iRob.ChangedPosition -= new RobMotors.PositionS(RobPosition);
			lblStatus.Text = "Auf Parkposition";
			iRob.MoveHome();
			iRob.WaitForDone();
			iRob.MoveTo(112);
			iRob.WaitForDone();
			fd.DisConnect();
			this.Close();
		}

		// --- cmdZyklus_Click : Arbeitszyklus ------------------------------

		private void cmdZyklus_Click(object sender, System.EventArgs e) {
			cmdZyklus.Enabled = false;
			iRob.MoveTo(145);               // --- Sule auf Pos 145
			iRob.WaitForDone();
			iRob.MoveTo(145, 45, 45);       // --- Arm auf Pos 45v / 45h
			iRob.WaitForDone();
			iRob.MoveTo(145, 45, 45, 24);   // --- Greifer schlieen
			iRob.WaitForDone();
			iRob.MoveTo(145, 0);            // --- Arm hoch auf 0
			iRob.WaitForDone();
			iRob.MoveTo( 45);               // --- Sule auf Pos 45
			iRob.WaitForDone();
			iRob.MoveTo( 45, 75);           // --- Arm vertikal 75
			iRob.WaitForDone();
			iRob.MoveTo( 45, 75, 45, 0);    // --- Greifer ffnen
			iRob.WaitForDone();
			cmdZyklus.Enabled = true;
		}
	}
}
