// ------------------------------------------------------------------------------------
//
// RoboStep.CS                                                   Ulrich Mller 22.06.05
//                                                               PCS1700   C# Final SP2
// Industry Robot : SulenRoboter
// Steuerung des Roboters durch Einzelfunktionen
//
// Robotaufbau entsprechend Bauanleitung
// Einsatz von FishDevices40.DLL / umFish40.DLL
//
// ------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishDevices40;

namespace RobStep
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button     cmdEnde;
		private System.Windows.Forms.Button     cmdAction;
		private System.Windows.Forms.Label      lblStatus;
		private System.Windows.Forms.ComboBox   cboPortName;
		private System.Windows.Forms.Panel      pnlSteps;
		private System.Windows.Forms.Button     cmdNachB;
		private System.Windows.Forms.Button     cmdGreifen;
		private System.Windows.Forms.Button     cmdNachA;
		private System.Windows.Forms.Button     cmdHome;
		private System.Windows.Forms.Button     cmdAblegen;
		private System.ComponentModel.Container components = null;

		// --- RoboFace : Klassendeklarationen -------------------------
		private FishDevices  fd;
		private RobMotor     mSaule;
		private RobMotor     mArmV;
		private RobMotor     mArmH;
		private RobMotor     mGreifer;

		public frmMain() {
			InitializeComponent();

			// --- RoboFace : Instanzierung ------------------
			fd       = new FishDevices();
			mSaule   = new RobMotor(fd, Out.M1, 222);
			mArmV    = new RobMotor(fd, Out.M3, 111);
			mArmH    = new RobMotor(fd, Out.M2, 88);
			mGreifer = new RobMotor(fd, Out.M4, 26);

			cboPortName.SelectedIndex = 2;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.pnlSteps = new System.Windows.Forms.Panel();
			this.cmdNachB = new System.Windows.Forms.Button();
			this.cmdGreifen = new System.Windows.Forms.Button();
			this.cmdNachA = new System.Windows.Forms.Button();
			this.cmdHome = new System.Windows.Forms.Button();
			this.cmdAblegen = new System.Windows.Forms.Button();
			this.pnlSteps.SuspendLayout();
			this.SuspendLayout();
			// 
			// cmdEnde
			// 
			this.cmdEnde.Location = new System.Drawing.Point(16, 336);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(168, 32);
			this.cmdEnde.TabIndex = 5;
			this.cmdEnde.Text = "&ENDE";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(16, 376);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(168, 32);
			this.cmdAction.TabIndex = 6;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.Color.White;
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(16, 240);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(168, 40);
			this.lblStatus.TabIndex = 7;
			this.lblStatus.Text = "START drcken";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cboPortName
			// 
			this.cboPortName.DisplayMember = "0;1;2;3;4";
			this.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPortName.Items.AddRange(new object[] {
															 "USB",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(16, 296);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(168, 21);
			this.cboPortName.TabIndex = 8;
			// 
			// pnlSteps
			// 
			this.pnlSteps.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.cmdNachB,
																				   this.cmdGreifen,
																				   this.cmdNachA,
																				   this.cmdHome,
																				   this.cmdAblegen});
			this.pnlSteps.Location = new System.Drawing.Point(8, 8);
			this.pnlSteps.Name = "pnlSteps";
			this.pnlSteps.Size = new System.Drawing.Size(184, 216);
			this.pnlSteps.TabIndex = 9;
			// 
			// cmdNachB
			// 
			this.cmdNachB.Location = new System.Drawing.Point(8, 56);
			this.cmdNachB.Name = "cmdNachB";
			this.cmdNachB.Size = new System.Drawing.Size(168, 32);
			this.cmdNachB.TabIndex = 9;
			this.cmdNachB.Text = "Nach &B";
			this.cmdNachB.Click += new System.EventHandler(this.cmdNachB_Click);
			// 
			// cmdGreifen
			// 
			this.cmdGreifen.Location = new System.Drawing.Point(8, 96);
			this.cmdGreifen.Name = "cmdGreifen";
			this.cmdGreifen.Size = new System.Drawing.Size(168, 32);
			this.cmdGreifen.TabIndex = 8;
			this.cmdGreifen.Text = "&Greifen";
			this.cmdGreifen.Click += new System.EventHandler(this.cmdGreifen_Click);
			// 
			// cmdNachA
			// 
			this.cmdNachA.Location = new System.Drawing.Point(8, 136);
			this.cmdNachA.Name = "cmdNachA";
			this.cmdNachA.Size = new System.Drawing.Size(168, 32);
			this.cmdNachA.TabIndex = 7;
			this.cmdNachA.Text = "Nach &A";
			this.cmdNachA.Click += new System.EventHandler(this.cmdNachA_Click);
			// 
			// cmdHome
			// 
			this.cmdHome.Location = new System.Drawing.Point(8, 176);
			this.cmdHome.Name = "cmdHome";
			this.cmdHome.Size = new System.Drawing.Size(168, 32);
			this.cmdHome.TabIndex = 6;
			this.cmdHome.Text = "&Home";
			this.cmdHome.Click += new System.EventHandler(this.cmdHome_Click);
			// 
			// cmdAblegen
			// 
			this.cmdAblegen.Location = new System.Drawing.Point(8, 16);
			this.cmdAblegen.Name = "cmdAblegen";
			this.cmdAblegen.Size = new System.Drawing.Size(168, 32);
			this.cmdAblegen.TabIndex = 5;
			this.cmdAblegen.Text = "Ab&legen";
			this.cmdAblegen.Click += new System.EventHandler(this.cmdAblegen_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(198, 429);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pnlSteps,
																		  this.cboPortName,
																		  this.lblStatus,
																		  this.cmdAction,
																		  this.cmdEnde});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "RoboFace : RobStep";
			this.pnlSteps.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		
		// --------- BetriebsRoutinen --------------------------------------

		// --- Home : Anfahren der Home-Position ----------------------

		private void Home() {
			lblStatus.Text = "Home";
			mSaule.DriveHome();
			mArmV.DriveHome();
			mArmH.DriveHome();
			mGreifer.DriveHome();
			mSaule.WaitForDone();
			mArmV.WaitForDone();
			mArmH.WaitForDone();
			mGreifer.WaitForDone();
			mSaule.DriveTo(10);
			mSaule.WaitForDone();
		}

		// --- Parken : Anfahren der Parkposition -------------------
		private void Parken() {
			Home();
			lblStatus.Text = "Parken";
			mSaule.DriveTo(110);
			mSaule.WaitForDone();
		}

		// --- Button-Routinen -------------------

		private void cmdAblegen_Click(object sender, System.EventArgs e) {
			pnlSteps.Enabled = false;
			lblStatus.Text = "Ablegen";
			mGreifer.DriveTo(0);
			mGreifer.WaitForDone();
			pnlSteps.Enabled = true;
		}

		private void cmdNachB_Click(object sender, System.EventArgs e) {
			pnlSteps.Enabled = false;
			lblStatus.Text = "Nach B";
			mArmV.DriveTo(0);
			mArmH.DriveTo(0);
			mArmV.WaitForDone();
			mArmH.WaitForDone();
			mSaule.DriveTo(10);
			mSaule.WaitForDone();
			pnlSteps.Enabled = true;
		}

		private void cmdGreifen_Click(object sender, System.EventArgs e) {
			pnlSteps.Enabled = false;
			lblStatus.Text = "Greifen";
			mGreifer.DriveTo(24);
			mGreifer.WaitForDone();
			pnlSteps.Enabled = true;
		}

		private void cmdNachA_Click(object sender, System.EventArgs e) {
			pnlSteps.Enabled = false;
			lblStatus.Text = "Nach A";
			mSaule.DriveTo(110);
			mSaule.WaitForDone();
			mArmV.DriveTo(45);
			mArmH.DriveTo(80);
			mArmV.WaitForDone();
			mArmH.WaitForDone();
			pnlSteps.Enabled = true;
		}

		private void cmdHome_Click(object sender, System.EventArgs e) {
			pnlSteps.Enabled = false;
			Home();
			pnlSteps.Enabled = true;
		}

		private void cmdEnde_Click(object sender, System.EventArgs e) {
			Parken();
			fd.DisConnect();
			this.Close();
		}

		// ---cmdAction_Click : Starten des Modellbetriebs ---------------

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try{
				if(cboPortName.SelectedIndex == 0) {
					fd.Connect(IFTypen.ftROBO_first_USB, 0);
				}
				else {
					fd.Connect(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 0);
				}
				cmdAction.Enabled = false;
				lblStatus.Text    = "luft";
			}
			catch(FishDevException efd) {
				lblStatus.Text = efd.Message;
			}
		}
	}
}
